## ktx 1.42%2Bdfsg

=== tools/q3asm/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.0)

project(q3asm C)
add_executable(q3asm q3asm.c q3vm.c cmdlib.c)
