=== debian/control ===
Source: ktx
Maintainer: Lee Garrett <debian@rocketjump.eu>
Section: games
Priority: optional
Build-Depends: debhelper-compat (= 13),
               cmake,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/games-team/ktx
Vcs-Git: https://salsa.debian.org/games-team/ktx.git
Homepage: https://github.com/QW-Group/ktx/

Package: ktx
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, mvdsv (>= 0.35)
Description: QuakeWorld mod "Kombat Teams eXtreme"
 KTX (Kombat Teams eXtreme) is a popular QuakeWorld server modification, adding
 numerous features to the core features of the server.
 .
 Although it had been developed to be Quakeworld server agnostic, it has over
 the years been developed very close to MVDSV to which it has become an extent,
 thus compatibility with other Quakeworld servers might not have been
 maintained.
