## ktx 1.44

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,6 +2,10 @@
 
 # Set project name and languge.
 project(qwprogs C)
+
+include(CheckCCompilerFlag)
+
+set(CMAKE_COLOR_DIAGNOSTICS ON)
 
 # CMake option for bot support, we check it below and add C preprocessor directive if required.
 option(BOT_SUPPORT "Build with bot support" ON)
@@ -64,6 +68,8 @@
 	"${DIR_SRC}/doors.c"
 	"${DIR_SRC}/fb_globals.c"
 	"${DIR_SRC}/files.c"
+	"${DIR_SRC}/func_bob.c"
+	"${DIR_SRC}/func_laser.c"
 	"${DIR_SRC}/g_cmd.c"
 	"${DIR_SRC}/globals.c"
 	"${DIR_SRC}/g_mem.c"
@@ -71,6 +77,8 @@
 	"${DIR_SRC}/g_spawn.c"
 	"${DIR_SRC}/g_userinfo.c"
 	"${DIR_SRC}/g_utils.c"
+	"${DIR_SRC}/g_syscalls_extra.c"
+	"${DIR_SRC}/hiprot.c"
 	"${DIR_SRC}/hoonymode.c"
 	"${DIR_SRC}/items.c"
 	"${DIR_SRC}/logs.c"
@@ -90,6 +98,9 @@
 	"${DIR_SRC}/player.c"
 	"${DIR_SRC}/q_shared.c"
 	"${DIR_SRC}/race.c"
+	"${DIR_SRC}/rng.c"
+	"${DIR_SRC}/rng_gen_impl.c"
+	"${DIR_SRC}/rng_seed_impl.c"
 	"${DIR_SRC}/route_calc.c"
 	"${DIR_SRC}/route_fields.c"
 	"${DIR_SRC}/route_lookup.c"
@@ -142,10 +153,30 @@
 endif()
 # If not Miscrosoft compilator - then set additional options for linker.
 if (CMAKE_C_COMPILER_ID STREQUAL "MSVC")
-	target_compile_options(${PROJECT_NAME} PRIVATE /W4)
+	# 4100 - unused parameter
+	# 4210 - using extern keyword in functions
+	# 4456 - shadowing locals, broadly used
+	# 4459 - shadowing globals, broadly used
+	target_compile_options(${PROJECT_NAME} PRIVATE /W4 /wd4100 /wd4210 /wd4456 /wd4459)
 else()
 	target_compile_options(${PROJECT_NAME} PRIVATE -Wall)
-	target_link_options(${PROJECT_NAME} PRIVATE "-Wl,--no-undefined") # Do not allow undefined symbols while linking.
+
+	check_c_compiler_flag("-Wstrict-prototypes" HAS_CFLAG_STRICT_PROTOTYPES)
+	if (HAS_CFLAG_STRICT_PROTOTYPES)
+		target_compile_options(${PROJECT_NAME} PRIVATE -Werror=strict-prototypes)
+	endif()
+
+	check_c_compiler_flag("-Wstrlcpy-strlcat-size" HAS_STRLCPY_STRLCAT_SIZE)
+	if (HAS_STRLCPY_STRLCAT_SIZE)
+		target_compile_options(${PROJECT_NAME} PRIVATE -Werror=strlcpy-strlcat-size)
+	endif()
+
+	# Do not allow undefined symbols while linking.
+	if(APPLE)
+		target_link_options(${PROJECT_NAME} PRIVATE "-Wl,-undefined,error")
+	else()
+		target_link_options(${PROJECT_NAME} PRIVATE "-Wl,--no-undefined")
+	endif()
 	target_link_libraries(${PROJECT_NAME} PRIVATE m) # Link with libm.
 endif()
 
@@ -153,7 +184,6 @@
 # Build QVM tools.
 # EXCLUDE_FROM_ALL tells to not build tools if they does not required, for example if you build native library only.
 add_subdirectory(tools/q3asm EXCLUDE_FROM_ALL)
-add_subdirectory(tools/q3lcc EXCLUDE_FROM_ALL)
 
 # Set up vars for QVM library.
 set(VM_DIR "vm")
@@ -166,7 +196,7 @@
 if(BOT_SUPPORT)
 	set(QVM_C_FLAGS ${QVM_C_FLAGS} -DBOT_SUPPORT=1)
 endif()
-set(QVM_INCFLAGS -I${CMAKE_CURRENT_SOURCE_DIR}/include)
+set(QVM_INCDIR "${CMAKE_CURRENT_SOURCE_DIR}/include")
 
 # Write first chunk of QVM_LIST_FILE.
 set(QVM_LIST_FILE "${CMAKE_CURRENT_BINARY_DIR}/game.q3asm")
@@ -178,9 +208,11 @@
 	string(CONCAT file_asm ${file_asm} ".asm") # Add asm extension.
 	list(APPEND SRC_ASM ${file_asm}) # Fill in SRC_ASM list. 
 	file(APPEND ${QVM_LIST_FILE} "${VM_DIR}/${file_asm}\n") # Continue generate QVM_LIST_FILE.
+	get_filename_component(src_dir ${file} DIRECTORY)
+	file(RELATIVE_PATH QVM_RELINCDIR "${CMAKE_CURRENT_SOURCE_DIR}/${src_dir}" "${QVM_INCDIR}")
 	# Add command to compile c to asm.
 	add_custom_target(${file_asm}
-		COMMAND ${QVM_COMPILER} ${QVM_C_FLAGS} ${QVM_INCFLAGS} "${CMAKE_CURRENT_SOURCE_DIR}/${file}" -o "${VM_DIR}/${file_asm}"
+		COMMAND ${QVM_COMPILER} ${QVM_C_FLAGS} -I${QVM_RELINCDIR} "${CMAKE_CURRENT_SOURCE_DIR}/${file}" -o "${VM_DIR}/${file_asm}"
 		DEPENDS vmdir
 		SOURCES ${file}
 	)
