=== debian/changelog ===
ktx (1.45-1) unstable; urgency=high

  * New upstream version 1.45
  * Update gbp config and switch to DEP-14 repo layout
  * Refresh quilt patches
  * Bump versioned dependency on mvdsv
  * Drop Files-Excluded from d/copyright (removed upstream)
  * Bump Standards-Version (no changes needed)
  * Update versioned mvdsv dependency

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 10 Apr 2025 14:13:44 +0200
