=== debian/control ===
--- 
+++ 
@@ -5,14 +5,14 @@
 Build-Depends: debhelper-compat (= 13),
                cmake,
 Rules-Requires-Root: no
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/games-team/ktx
 Vcs-Git: https://salsa.debian.org/games-team/ktx.git
 Homepage: https://github.com/QW-Group/ktx/
 
 Package: ktx
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, mvdsv (>= 0.35)
+Depends: ${shlibs:Depends}, ${misc:Depends}, mvdsv (>= 1.11)
 Description: QuakeWorld mod "Kombat Teams eXtreme"
  KTX (Kombat Teams eXtreme) is a popular QuakeWorld server modification, adding
  numerous features to the core features of the server.
